From 03252470c0008443a3903eed56d3b8b96a27ed55 Mon Sep 17 00:00:00 2001
From: Micael Karlberg <bmk@erlang.org>
Date: Tue, 18 Jun 2019 17:27:33 +0200
Subject: [PATCH 46/73] [esock] socket:setopt add_membership fails with badarg

An invalid value test caused the

     socket:setopt(Socket, ip, add_membership, ip_mreq())

to fail with badarg.

OTP-15908 (ERL-980)
---
 erts/emulator/nifs/common/socket_nif.c | 100 ++++++++++++++++++++-----
 1 file changed, 82 insertions(+), 18 deletions(-)

diff --git a/erts/emulator/nifs/common/socket_nif.c b/erts/emulator/nifs/common/socket_nif.c
index ee3b9f2a985..dc0847fa397 100644
--- a/erts/emulator/nifs/common/socket_nif.c
+++ b/erts/emulator/nifs/common/socket_nif.c
@@ -8860,35 +8860,67 @@ ERL_NIF_TERM nsetopt_lvl_ip_update_membership(ErlNifEnv*       env,
 #endif
 
     // It must be a map
-    if (!IS_MAP(env, eVal))
+    if (!IS_MAP(env, eVal)) {
+        SSDBG( descP,
+               ("SOCKET", "nsetopt_lvl_ip_update_membership -> "
+                "value *not* a map\r\n") );
         return enif_make_badarg(env);
+    }
 
     // It must have atleast two attributes
-    if (!enif_get_map_size(env, eVal, &sz) || (sz >= 2))
+    if (!enif_get_map_size(env, eVal, &sz) || (sz < 2)) {
+        SSDBG( descP,
+               ("SOCKET", "nsetopt_lvl_ip_update_membership -> "
+                "invalid map value: %T\r\n", eVal) );
         return enif_make_badarg(env);
+    }
 
-    if (!GET_MAP_VAL(env, eVal, atom_multiaddr, &eMultiAddr))
+    if (!GET_MAP_VAL(env, eVal, atom_multiaddr, &eMultiAddr)) {
+        SSDBG( descP,
+               ("SOCKET", "nsetopt_lvl_ip_update_membership -> "
+                "failed get multiaddr (map) attribute\r\n") );
         return enif_make_badarg(env);
+    }
 
-    if (!GET_MAP_VAL(env, eVal, atom_interface, &eInterface))
+    if (!GET_MAP_VAL(env, eVal, atom_interface, &eInterface)) {
+        SSDBG( descP,
+               ("SOCKET", "nsetopt_lvl_ip_update_membership -> "
+                "failed get interface (map) attribute\r\n") );
         return enif_make_badarg(env);
+    }
 
     if ((xres = esock_decode_ip4_address(env,
                                          eMultiAddr,
-                                         &mreq.imr_multiaddr)) != NULL)
+                                         &mreq.imr_multiaddr)) != NULL) {
+        SSDBG( descP,
+               ("SOCKET", "nsetopt_lvl_ip_update_membership -> "
+                "failed decode multiaddr %T: %s\r\n", eMultiAddr, xres) );
         return esock_make_error_str(env, xres);
+    }
 
     if ((xres = esock_decode_ip4_address(env,
                                          eInterface,
-                                         &mreq.imr_interface)) != NULL)
+                                         &mreq.imr_interface)) != NULL) {
+        SSDBG( descP,
+               ("SOCKET", "nsetopt_lvl_ip_update_membership -> "
+                "failed decode interface %T: %s\r\n", eInterface, xres) );
         return esock_make_error_str(env, xres);
+    }
 
     res = socket_setopt(descP->sock, level, opt, &mreq, sizeof(mreq));
 
-    if (res != 0)
-        result = esock_make_error_errno(env, sock_errno());
-    else
+    if (res != 0) {
+        int save_errno = sock_errno();
+
+        result = esock_make_error_errno(env, save_errno);
+
+        SSDBG( descP,
+               ("SOCKET", "nsetopt_lvl_ip_update_membership -> "
+                "failed setopt: %T (%d)\r\n", result, save_errno) );
+
+    } else {
         result = esock_atom_ok;
+    }
 
     return result;
 }
@@ -9492,33 +9524,65 @@ ERL_NIF_TERM nsetopt_lvl_ipv6_update_membership(ErlNifEnv*       env,
 #endif
 
     // It must be a map
-    if (!IS_MAP(env, eVal))
+    if (!IS_MAP(env, eVal)) {
+        SSDBG( descP,
+               ("SOCKET", "nsetopt_lvl_ipv6_update_membership -> "
+                "value *not* a map\r\n") );
         return enif_make_badarg(env);
+    }
 
     // It must have atleast two attributes
-    if (!enif_get_map_size(env, eVal, &sz) || (sz >= 2))
+    if (!enif_get_map_size(env, eVal, &sz) || (sz < 2)) {
+        SSDBG( descP,
+               ("SOCKET", "nsetopt_lvl_ipv6_update_membership -> "
+                "invalid map value: %T\r\n", eVal) );
         return enif_make_badarg(env);
+    }
 
-    if (!GET_MAP_VAL(env, eVal, atom_multiaddr, &eMultiAddr))
+    if (!GET_MAP_VAL(env, eVal, atom_multiaddr, &eMultiAddr)) {
+        SSDBG( descP,
+               ("SOCKET", "nsetopt_lvl_ipv6_update_membership -> "
+                "failed get multiaddr (map) attribute\r\n") );
         return enif_make_badarg(env);
+    }
 
-    if (!GET_MAP_VAL(env, eVal, atom_interface, &eInterface))
+    if (!GET_MAP_VAL(env, eVal, atom_interface, &eInterface)) {
+        SSDBG( descP,
+               ("SOCKET", "nsetopt_lvl_ipv6_update_membership -> "
+                "failed get interface (map) attribute\r\n") );
         return enif_make_badarg(env);
+    }
 
     if ((xres = esock_decode_ip6_address(env,
                                          eMultiAddr,
-                                         &mreq.ipv6mr_multiaddr)) != NULL)
+                                         &mreq.ipv6mr_multiaddr)) != NULL) {
+        SSDBG( descP,
+               ("SOCKET", "nsetopt_lvl_ipv6_update_membership -> "
+                "failed decode multiaddr %T: %s\r\n", eMultiAddr, xres) );
         return esock_make_error_str(env, xres);
+    }
 
-    if (!GET_UINT(env, eInterface, &mreq.ipv6mr_interface))
+    if (!GET_UINT(env, eInterface, &mreq.ipv6mr_interface)) {
+        SSDBG( descP,
+               ("SOCKET", "nsetopt_lvl_ip_update_membership -> "
+                "failed decode interface %T: %s\r\n", eInterface, xres) );
         return esock_make_error(env, esock_atom_einval);
+    }
 
     res = socket_setopt(descP->sock, level, opt, &mreq, sizeof(mreq));
 
-    if (res != 0)
-        result = esock_make_error_errno(env, sock_errno());
-    else
+    if (res != 0) {
+        int save_errno = sock_errno();
+
+        result = esock_make_error_errno(env, save_errno);
+
+        SSDBG( descP,
+               ("SOCKET", "nsetopt_lvl_ipv6_update_membership -> "
+                "failed setopt: %T (%d)\r\n", result, save_errno) );
+
+    } else {
         result = esock_atom_ok;
+    }
 
     return result;
 }

